/*******************************************************************************
  TPI - flexible but useless plug-in framework.
  Copyright (C) 2002-2009 Silky

  This library is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation; either version 2.1 of the License, or (at your option)
  any later version.

  This library is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License
  for more details.

  You should have received a copy of the GNU Lesser General Public License along
  with this library; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

  $Id$
*******************************************************************************/

#ifndef __TPI_API_SPEC_EXTRA
#define __TPI_API_SPEC_EXTRA

//******************************************************************************
//    Defines
//******************************************************************************

//
// Extra Error Codes
//
#define TPI_ERROR_IO_MISC_MISC      TPI_ERROR_T_IO_MISC + TPI_ERROR_IO_MISC
#define TPI_ERROR_IO_MISC_NOTFOUND  TPI_ERROR_T_IO_MISC + TPI_ERROR_IO_NOTFOUND
#define TPI_ERROR_IO_MISC_ACCESS    TPI_ERROR_T_IO_MISC + TPI_ERROR_IO_ACCESS
#define TPI_ERROR_IO_MISC_OPEN      TPI_ERROR_T_IO_MISC + TPI_ERROR_IO_OPEN
#define TPI_ERROR_IO_MISC_CLOSE     TPI_ERROR_T_IO_MISC + TPI_ERROR_IO_CLOSE
#define TPI_ERROR_IO_MISC_READ      TPI_ERROR_T_IO_MISC + TPI_ERROR_IO_READ
#define TPI_ERROR_IO_MISC_WRITE     TPI_ERROR_T_IO_MISC + TPI_ERROR_IO_WRITE
#define TPI_ERROR_IO_MISC_GETINFO   TPI_ERROR_T_IO_MISC + TPI_ERROR_IO_GETINFO
#define TPI_ERROR_IO_MISC_POINT     TPI_ERROR_T_IO_MISC + TPI_ERROR_IO_POINT
#define TPI_ERROR_IO_MISC_COPY      TPI_ERROR_T_IO_MISC + TPI_ERROR_IO_COPY
#define TPI_ERROR_IO_MISC_MOVE      TPI_ERROR_T_IO_MISC + TPI_ERROR_IO_MOVE
#define TPI_ERROR_IO_MISC_DELETE    TPI_ERROR_T_IO_MISC + TPI_ERROR_IO_DELETE
#define TPI_ERROR_IO_MISC_SETINFO   TPI_ERROR_T_IO_MISC + TPI_ERROR_IO_SETINFO

#define TPI_ERROR_IO_ARC_MISC       TPI_ERROR_T_IO_ARCHIVE + TPI_ERROR_IO_MISC
#define TPI_ERROR_IO_ARC_NOTFOUND   TPI_ERROR_T_IO_ARCHIVE + TPI_ERROR_IO_NOTFOUND
#define TPI_ERROR_IO_ARC_ACCESS     TPI_ERROR_T_IO_ARCHIVE + TPI_ERROR_IO_ACCESS
#define TPI_ERROR_IO_ARC_OPEN       TPI_ERROR_T_IO_ARCHIVE + TPI_ERROR_IO_OPEN
#define TPI_ERROR_IO_ARC_CLOSE      TPI_ERROR_T_IO_ARCHIVE + TPI_ERROR_IO_CLOSE
#define TPI_ERROR_IO_ARC_READ       TPI_ERROR_T_IO_ARCHIVE + TPI_ERROR_IO_READ
#define TPI_ERROR_IO_ARC_WRITE      TPI_ERROR_T_IO_ARCHIVE + TPI_ERROR_IO_WRITE
#define TPI_ERROR_IO_ARC_GETINFO    TPI_ERROR_T_IO_ARCHIVE + TPI_ERROR_IO_GETINFO
#define TPI_ERROR_IO_ARC_POINT      TPI_ERROR_T_IO_ARCHIVE + TPI_ERROR_IO_POINT
#define TPI_ERROR_IO_ARC_COPY       TPI_ERROR_T_IO_ARCHIVE + TPI_ERROR_IO_COPY
#define TPI_ERROR_IO_ARC_MOVE       TPI_ERROR_T_IO_ARCHIVE + TPI_ERROR_IO_MOVE
#define TPI_ERROR_IO_ARC_DELETE     TPI_ERROR_T_IO_ARCHIVE + TPI_ERROR_IO_DELETE
#define TPI_ERROR_IO_ARC_SETINFO    TPI_ERROR_T_IO_ARCHIVE + TPI_ERROR_IO_SETINFO

#define TPI_ERROR_IO_FILE_MISC      TPI_ERROR_T_IO_FILE + TPI_ERROR_IO_MISC
#define TPI_ERROR_IO_FILE_NOTFOUND  TPI_ERROR_T_IO_FILE + TPI_ERROR_IO_NOTFOUND
#define TPI_ERROR_IO_FILE_ACCESS    TPI_ERROR_T_IO_FILE + TPI_ERROR_IO_ACCESS
#define TPI_ERROR_IO_FILE_OPEN      TPI_ERROR_T_IO_FILE + TPI_ERROR_IO_OPEN
#define TPI_ERROR_IO_FILE_CLOSE     TPI_ERROR_T_IO_FILE + TPI_ERROR_IO_CLOSE
#define TPI_ERROR_IO_FILE_READ      TPI_ERROR_T_IO_FILE + TPI_ERROR_IO_READ
#define TPI_ERROR_IO_FILE_WRITE     TPI_ERROR_T_IO_FILE + TPI_ERROR_IO_WRITE
#define TPI_ERROR_IO_FILE_GETINFO   TPI_ERROR_T_IO_FILE + TPI_ERROR_IO_GETINFO
#define TPI_ERROR_IO_FILE_POINT     TPI_ERROR_T_IO_FILE + TPI_ERROR_IO_POINT
#define TPI_ERROR_IO_FILE_COPY      TPI_ERROR_T_IO_FILE + TPI_ERROR_IO_COPY
#define TPI_ERROR_IO_FILE_MOVE      TPI_ERROR_T_IO_FILE + TPI_ERROR_IO_MOVE
#define TPI_ERROR_IO_FILE_DELETE    TPI_ERROR_T_IO_FILE + TPI_ERROR_IO_DELETE
#define TPI_ERROR_IO_FILE_SETINFO   TPI_ERROR_T_IO_FILE + TPI_ERROR_IO_SETINFO

#define TPI_ERROR_IO_TMP_MISC       TPI_ERROR_T_IO_WORKING + TPI_ERROR_IO_MISC
#define TPI_ERROR_IO_TMP_NOTFOUND   TPI_ERROR_T_IO_WORKING + TPI_ERROR_IO_NOTFOUND
#define TPI_ERROR_IO_TMP_ACCESS     TPI_ERROR_T_IO_WORKING + TPI_ERROR_IO_ACCESS
#define TPI_ERROR_IO_TMP_OPEN       TPI_ERROR_T_IO_WORKING + TPI_ERROR_IO_OPEN
#define TPI_ERROR_IO_TMP_CLOSE      TPI_ERROR_T_IO_WORKING + TPI_ERROR_IO_CLOSE
#define TPI_ERROR_IO_TMP_READ       TPI_ERROR_T_IO_WORKING + TPI_ERROR_IO_READ
#define TPI_ERROR_IO_TMP_WRITE      TPI_ERROR_T_IO_WORKING + TPI_ERROR_IO_WRITE
#define TPI_ERROR_IO_TMP_GETINFO    TPI_ERROR_T_IO_WORKING + TPI_ERROR_IO_GETINFO
#define TPI_ERROR_IO_TMP_POINT      TPI_ERROR_T_IO_WORKING + TPI_ERROR_IO_POINT
#define TPI_ERROR_IO_TMP_COPY       TPI_ERROR_T_IO_WORKING + TPI_ERROR_IO_COPY
#define TPI_ERROR_IO_TMP_MOVE       TPI_ERROR_T_IO_WORKING + TPI_ERROR_IO_MOVE
#define TPI_ERROR_IO_TMP_DELETE     TPI_ERROR_T_IO_WORKING + TPI_ERROR_IO_DELETE
#define TPI_ERROR_IO_TMP_SETINFO    TPI_ERROR_T_IO_WORKING + TPI_ERROR_IO_SETINFO

#define TPI_ERROR_IO_DIR_MISC       TPI_ERROR_T_IO_DIRECTORY + TPI_ERROR_IO_MISC
#define TPI_ERROR_IO_DIR_NOTFOUND   TPI_ERROR_T_IO_DIRECTORY + TPI_ERROR_IO_NOTFOUND
#define TPI_ERROR_IO_DIR_ACCESS     TPI_ERROR_T_IO_DIRECTORY + TPI_ERROR_IO_ACCESS
#define TPI_ERROR_IO_DIR_OPEN       TPI_ERROR_T_IO_DIRECTORY + TPI_ERROR_IO_OPEN
#define TPI_ERROR_IO_DIR_CLOSE      TPI_ERROR_T_IO_DIRECTORY + TPI_ERROR_IO_CLOSE
#define TPI_ERROR_IO_DIR_READ       TPI_ERROR_T_IO_DIRECTORY + TPI_ERROR_IO_READ
#define TPI_ERROR_IO_DIR_WRITE      TPI_ERROR_T_IO_DIRECTORY + TPI_ERROR_IO_WRITE
#define TPI_ERROR_IO_DIR_GETINFO    TPI_ERROR_T_IO_DIRECTORY + TPI_ERROR_IO_GETINFO
#define TPI_ERROR_IO_DIR_POINT      TPI_ERROR_T_IO_DIRECTORY + TPI_ERROR_IO_POINT
#define TPI_ERROR_IO_DIR_COPY       TPI_ERROR_T_IO_DIRECTORY + TPI_ERROR_IO_COPY
#define TPI_ERROR_IO_DIR_MOVE       TPI_ERROR_T_IO_DIRECTORY + TPI_ERROR_IO_MOVE
#define TPI_ERROR_IO_DIR_DELETE     TPI_ERROR_T_IO_DIRECTORY + TPI_ERROR_IO_DELETE
#define TPI_ERROR_IO_DIR_SETINFO    TPI_ERROR_T_IO_DIRECTORY + TPI_ERROR_IO_SETINFO

#endif /* __TPI_API_SPEC_EXTRA */
