/*******************************************************************************
  TPI - flexible but useless plug-in framework.
  Copyright (C) 2002-2009 Silky

  This library is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the Free
  Software Foundation; either version 2.1 of the License, or (at your option)
  any later version.

  This library is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License
  for more details.

  You should have received a copy of the GNU Lesser General Public License along
  with this library; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

  $Id$
*******************************************************************************/

#ifndef H_LOADED_CLS_FDT
#define H_LOADED_CLS_FDT

#define wxUSE_DRAG_AND_DROP 1
#include <wx/dnd.h>

//******************************************************************************
//    Class (myFileDropTarget)
//******************************************************************************

class myFileDropTarget: public wxFileDropTarget
{
public:
	virtual bool OnDropFiles(wxCoord, wxCoord, const wxArrayString &);

	myFileDropTarget(MainFrame *);
	wxArrayString as;

private:
	MainFrame * mainFrame;
};

//******************************************************************************
//    Class (myFileDataObject)
//******************************************************************************

#ifdef __LINUX__
class myFileDataObject : public wxCustomDataObject
#else
class myFileDataObject : public wxFileDataObject
#endif
{
public:
#ifdef __LINUX__
	myFileDataObject() : wxCustomDataObject(wxDF_FILENAME){};
#endif
	~myFileDataObject();
#ifdef __LINUX__
	virtual bool GetDataHere(void *) const;
	virtual size_t GetDataSize() const;
	void AddFile(const wxString &);
	const wxArrayString& GetFilenames() const { return m_filenames; }
#endif
	wxString szTempDir;

#ifdef __LINUX__
protected:
	wxArrayString m_filenames;
#endif
};

#endif
